void writeStringToFile(int f,string thestring){
//save symbol string 
  char sysave[];
  int charstotal=StringToCharArray(thestring,sysave,0,StringLen(thestring),CP_ACP);
      FileWriteInteger(f,charstotal,INT_VALUE);
      for(int i=0;i<charstotal;i++){
         FileWriteInteger(f,sysave[i],CHAR_VALUE);
         }
}
string readStringFromFile(int f){
string result="";
//load symbol string 
  char syload[];
  int charstotal=(int)FileReadInteger(f,INT_VALUE);
      if(charstotal>0){
        ArrayResize(syload,charstotal,0);
        for(int i=0;i<charstotal;i++){
           syload[i]=(char)FileReadInteger(f,CHAR_VALUE);
           }
        result=CharArrayToString(syload,0,charstotal,CP_ACP);
        }
return(result);
}

class molecule{
        public:
 double value;
        molecule(void){reset();}
       ~molecule(void){reset();}
   void reset(){
        value=0.0;
        } 
   void set(double v){value=v;}
   void save(int f){
        FileWriteDouble(f,value); 
        }
   void load(int f){
        reset();
        value=(double)FileReadDouble(f);
        }     
};

//bottom item
class bottom_item{
          public:
     char cv;
 datetime time;
   double price;
      int integer;
     long l;
     bool b;
 molecule atoms[];
          bottom_item(void){reset();}
         ~bottom_item(void){reset();}
     void reset(){
          ArrayFree(atoms);
          cv=0;
          time=0;
          price=0.0;
          integer=0;
          l=0;
          b=false;
          }
     void setup(int seed,int atoms_total){
          cv=(char)(seed);
          time=(datetime)(((long)D'2024.07.25 00:00')-((long)seed*60));
          price=seed;
          integer=seed;
          l=seed;
          b=false;
          if(MathMod(seed,2)==0){b=true;}
          ArrayResize(atoms,atoms_total,0);
          for(int i=0;i<ArraySize(atoms);i++){
             atoms[i].set(price);
             }
          }
     bool is_same(bottom_item &other_item){
          if(cv==other_item.cv){
            if(time==other_item.time){
              if(price==other_item.price){
                if(integer==other_item.integer){
                  if(l==other_item.l){
                    if(b==other_item.b){
                      if(ArraySize(atoms)==ArraySize(other_item.atoms)){
                        for(int i=0;i<ArraySize(atoms);i++){  
                           if(atoms[i].value!=other_item.atoms[i].value){
                             return(false);
                             }
                           }
                         return(true);                       
                        }
                      }
                    }
                  }
                }
              }
            }
          return(false);
          }
     void save(int f){
          FileWriteInteger(f,ArraySize(atoms),INT_VALUE);
          for(int i=0;i<ArraySize(atoms);i++){
             atoms[i].save(f);
             }
          FileWriteInteger(f,cv,CHAR_VALUE);
          FileWriteLong(f,((long)time));
          FileWriteDouble(f,price);
          FileWriteInteger(f,integer,INT_VALUE);
          FileWriteLong(f,l);
          FileWriteInteger(f,((char)b),CHAR_VALUE);         
          }
     void load(int f){
          reset();
          int total=(int)FileReadInteger(f,INT_VALUE);
          if(total>0){
            ArrayResize(atoms,total,0);
            for(int i=0;i<total;i++){
               atoms[i].load(f);
               }
            }
          cv=(char)FileReadInteger(f,CHAR_VALUE);
          time=(datetime)FileReadLong(f);
          price=(double)FileReadDouble(f);
          integer=(int)FileReadInteger(f,INT_VALUE);
          l=(long)FileReadLong(f);
          b=(bool)FileReadInteger(f,CHAR_VALUE);
          }
};

class shelf{
            public: 
bottom_item items[];
        int shelf_id;
            shelf(void){reset();}
           ~shelf(void){reset();}
       void reset(){
            shelf_id=-1;
            ArrayFree(items);
            }
       void setup(int id,int _items,int _atoms){
            ArrayResize(items,_items,0);
            shelf_id=id;
            for(int i=0;i<_items;i++){
               items[i].setup(i,_atoms);
               }
            }
       bool is_same(shelf &other_shelf){
            if(shelf_id==other_shelf.shelf_id){
              if(ArraySize(items)==ArraySize(other_shelf.items)){                
                for(int i=0;i<ArraySize(items);i++){
                   if(!items[i].is_same(other_shelf.items[i])){
                     return(false); 
                     }
                   }
                return(true);
                }
              }
            return(false);
            }
       void save(int f){
            FileWriteInteger(f,shelf_id,INT_VALUE);
            FileWriteInteger(f,ArraySize(items),INT_VALUE);
            for(int i=0;i<ArraySize(items);i++){
               items[i].save(f); 
               }
            }
       void load(int f){
            reset();
            shelf_id=(int)FileReadInteger(f,INT_VALUE);
            int total=(int)FileReadInteger(f,INT_VALUE);
            if(total>0){
              ArrayResize(items,total,0);
              for(int i=0;i<total;i++){
                 items[i].load(f);
                 }
              }
            }
};

struct shelf_collection{
  string name;
   shelf shelves[];
datetime time;
         shelf_collection(void){reset();}
        ~shelf_collection(void){reset();}
    void reset(){
         name=NULL;
         ArrayFree(shelves);
         time=0;
         }
    void setup(string _name,
                  int _shelves,
                  int _items,
                  int _atoms,
                  datetime _time){
         name=_name;
         ArrayResize(shelves,_shelves,0);
         for(int i=0;i<_shelves;i++){
            shelves[i].setup(i,_items,_atoms);
            }
         time=_time;
         }
    bool is_same(shelf_collection &other_collection){
         if(name==other_collection.name){
           if(ArraySize(shelves)==ArraySize(other_collection.shelves)){
             if(time==other_collection.time){
               for(int i=0;i<ArraySize(shelves);i++){
                  if(!shelves[i].is_same(other_collection.shelves[i])){
                    return(false);
                    }
                  }
               return(true);
               }
             }
           }
         return(false);
         }
    void save(string folder,string filename){
         string location=folder+"\\"+filename;
         if(FileIsExist(location)){FileDelete(location);}
         int f=FileOpen(location,FILE_WRITE|FILE_BIN);
         if(f!=INVALID_HANDLE){
           writeStringToFile(f,name);
           FileWriteInteger(f,ArraySize(shelves),INT_VALUE);
           for(int i=0;i<ArraySize(shelves);i++){
              shelves[i].save(f);
              }
           FileWriteLong(f,((long)time));
           FileClose(f);
           }
         }
    bool load(string folder,string filename){
         reset();
         string location=folder+"\\"+filename;
         if(FileIsExist(location)){
         int f=FileOpen(location,FILE_READ|FILE_BIN);
         if(f!=INVALID_HANDLE){
           name=readStringFromFile(f);
           int total=(int)FileReadInteger(f,INT_VALUE);
           if(total>0){
             ArrayResize(shelves,total,0);
             for(int i=0;i<total;i++){
                shelves[i].load(f);
                }
             }
           time=(datetime)FileReadLong(f);
           FileClose(f);
           return(true);
           }
         }
         return(false);
         }
};